(function() {
  var Reader, Response, ResponseReader, Writer, outcome, _,
    __hasProp = Object.prototype.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; };

  Writer = require("../io/writer");

  Reader = require("../io/reader");

  _ = require("underscore");

  outcome = require("outcome");

  ResponseReader = (function(_super) {

    __extends(ResponseReader, _super);

    function ResponseReader() {
      ResponseReader.__super__.constructor.apply(this, arguments);
    }

    /*
    */

    ResponseReader.prototype._listenTo = function() {
      return ResponseReader.__super__._listenTo.call(this).concat("headers");
    };

    /*
    */

    ResponseReader.prototype._listen = function() {
      var _this = this;
      ResponseReader.__super__._listen.call(this);
      return this.on("headers", function(headers) {
        return _this.headers = headers;
      });
    };

    ResponseReader.prototype._dumpCached = function(pipedReader) {
      if (this.headers) pipedReader.emit("headers", this.headers);
      return ResponseReader.__super__._dumpCached.call(this, pipedReader);
    };

    return ResponseReader;

  })(Reader);

  module.exports = Response = (function(_super) {

    __extends(Response, _super);

    /*
    */

    function Response(messenger) {
      var _this = this;
      this.messenger = messenger;
      Response.__super__.constructor.call(this);
      this._headers = {};
      this.once("data", function() {
        return _this.sendHeaders();
      });
      this.once("end", function() {
        return _this.sendHeaders();
      });
    }

    /*
    */

    Response.prototype.header = function(typeOrObj, value) {
      if (typeof typeOrObj === "object") {
        _.extend(this._headers, typeOrObj);
      } else {
        this._headers[typeOrObj] = value;
      }
      return this;
    };

    /*
    	 DEPRECATED
    */

    Response.prototype.headers = function(typeOrObj, value) {
      return this.header(typeOrObj, value);
    };

    /*
    */

    /*
    */

    /*
    	 wrap-around for error handling
    */

    Response.prototype.success = function(success) {
      var _this = this;
      if (!this._outcome) {
        this._outcome = outcome.error(function(err) {
          return _this.error(err);
        });
      }
      return this._outcome.success(success);
    };

    /*
    */

    Response.prototype.sendHeaders = function() {
      if (this.sentHeaders) return this;
      this.sentHeaders = true;
      this.emit("headers", this._headers);
      return this;
    };

    /*
    */

    Response.prototype.reader = function() {
      return new ResponseReader(this);
    };

    return Response;

  })(Writer);

  Writer.prototype.writable = true;

}).call(this);
